<script>
import { shuffle } from 'lodash'
import { computed,ref, watch } from 'vue'
import Card from '@/components/Card.vue'

export default {
  name: "Cardgame",

  components: {
    Card
  },

  setup() {
    const cardsArray = ref([])
    const userSelection = ref([])

    const status = computed(() => {
      if (remainingPairs.value === 0) {
        return "Congrats, you win!"
      } else {
        return `Remaining Pairs: ${remainingPairs.value}`
      }
    })

    const remainingPairs = computed(() => {
      const remainingCards = cardsArray.value.filter(card => card.match === false).length

      return remainingCards / 2
    })

    const restart = () => {
      cardsArray.value = shuffle(cardsArray.value)

      cardsArray.value = cardsArray.value.map((card, index) => {
        return {
          ...card,
          match: false,
          position: index,
          visible: false
        }
      })
    }

    const deck = [1,2,3,4,5,6,7,8]

    deck.forEach(item => {
      cardsArray.value.push({
        value: item,
        variant: 1,
        visible: false,
        position: null,
        match: false
      })

      cardsArray.value.push({
        value: item,
        variant: 2,
        visible: false,
        position: null,
        match: false
      })
    })

    cardsArray.value = cardsArray.value.map((card, index) => {
      return {
        ...card,
        position: index
      }
    })

    const flipCard = (payload) => {
      cardsArray.value[payload.position].visible = true

      if (userSelection.value[0]) {
        if (
        userSelection.value[0].position === payload.position &&
        userSelection.value[0].faceValue === payload.faceValue
        ) {
          return
        } else {
          userSelection.value[1] = payload
        }
      } else {
        userSelection.value[0] = payload
      }
    }
    
    watch(userSelection, currentValue => {
      if(currentValue.length === 2) {
        const card1 = currentValue[0]
        const card2 = currentValue[1]

        if (card1.faceValue === card2.faceValue) {
          cardsArray.value[card1.position].match = true
          cardsArray.value[card2.position].match = true
        } else {
          setTimeout(() => {
            cardsArray.value[card1.position].visible = false
            cardsArray.value[card2.position].visible = false
          }, 800)
        }

        userSelection.value.length = 0
      }
    }, { deep: true })

    return {
      cardsArray,
      flipCard, 
      userSelection,
      status,
      restart,
    }
  }
}
</script>

<style scoped>
  .table{
    display: grid;
    justify-content: center;
    grid-template-columns: 70px 70px 70px 70px;
    grid-column-gap: 20px;
    grid-template-rows: 70px 70px 70px 70px;
    grid-row-gap: 20px;
    background-color: rgb(70, 7, 64);
    padding: 50px;
  }

  .status{
    text-align: center;
  }
</style>

<template>
  <div>
  <h1>Cardgame: Memory</h1>
  <h3>Click "shuffle cards" to begin the game:</h3>
  <button @click="restart">Shuffle Cards!</button>
  <h2 class="status"> {{ status }} </h2>
  <section class="table">
    <Card 
    v-for="card in cardsArray"
    :key="`${card.value}-${card.variant}`" 
    :match="card.match"
    :value="card.value"
    :visible="card.visible"
    :position="card.position"
    @selectCard="flipCard"/>
  </section>
  </div>
</template>
